import java.applet.Applet;
import java.awt.*;

public class IObserverDemo extends Applet
{
  boolean bImagesLoaded = false;
  Image img;
  int curX = 0;
  int curY = 0;
  int curWidth = 0;
  int curHeight = 0;
  
  // ============================================
  // init
  // ============================================
  public void init()
  {
    img = getImage(getDocumentBase(), 
      "img1.jpg");
  }
  
  // ============================================
  // imageUpdate
  // ============================================
  public boolean imageUpdate(Image img, int bFlags,
    int x, int y, int width, int height)
  {
    bImagesLoaded = ((bFlags & ALLBITS) != 0);
    
    if(bImagesLoaded)
      repaint();
      
    if((bFlags & SOMEBITS) != 0)
    {
      curX = x;
      curY = y;
      curWidth = width;
      curHeight = height;
      
      repaint();
    }
      
    return !bImagesLoaded;  
  }

  // ============================================
  // update
  // ============================================
  public void update(Graphics g)
  {
    paint(g);
  }
    
  // ============================================
  // paint
  // ============================================
  public void paint(Graphics g)
  {
    g.drawImage(img, 0, 0, this);
  }
  
  // ============================================
  // getAppletInfo
  // ============================================
  public String getAppletInfo()
  {
    return "Name: IObserverDemo";
  }
}